Skylib module containing convenience interfaces for select().

## selects.config_setting_group

load("@bazel_skylib//lib:selects.bzl", "selects")

selects.config_setting_group(name, match_any, match_all, visibility)

Matches if all or any of its member `config_setting`s match.

Example:

  ```build
  config_setting(name = "one", define_values = {"foo": "true"})
  config_setting(name = "two", define_values = {"bar": "false"})
  config_setting(name = "three", define_values = {"baz": "more_false"})

  config_setting_group(
      name = "one_two_three",
      match_all = [":one", ":two", ":three"]
  )

  cc_binary(
      name = "myapp",
      srcs = ["myapp.cc"],
      deps = select({
          ":one_two_three": [":special_deps"],
          "//conditions:default": [":default_deps"]
      })
  ```


**PARAMETERS**

| Name  | Description | Default Value |
| :------------- | :------------- | :------------- |
| name |  The group's name. This is how `select()`s reference it.   |  none |
| match_any |  A list of `config_settings`. This group matches if *any* member in the list matches. If this is set, `match_all` must not be set.   |  `[]` |
| match_all |  A list of `config_settings`. This group matches if *every* member in the list matches. If this is set, `match_any` must be not set.   |  `[]` |
| visibility |  Visibility of the config_setting_group.   |  `None` |

## selects.with_or

load("@bazel_skylib//lib:selects.bzl", "selects")

selects.with_or(input_dict, no_match_error)

Drop-in replacement for `select()` that supports ORed keys.

Example:

      ```build
      deps = selects.with_or({
          "//configs:one": [":dep1"],
          ("//configs:two", "//configs:three"): [":dep2or3"],
          "//configs:four": [":dep4"],
          "//conditions:default": [":default"]
      })
      ```

      Key labels may appear at most once anywhere in the input.


**PARAMETERS**

| Name  | Description | Default Value |
| :------------- | :------------- | :------------- |
| input_dict |  The same dictionary `select()` takes, except keys may take either the usual form `"//foo:config1"` or `("//foo:config1", "//foo:config2", ...)` to signify `//foo:config1` OR `//foo:config2` OR `...`.   |  none |
| no_match_error |  Optional custom error to report if no condition matches.   |  `""` |

**RETURNS**

A native `select()` that expands

`("//configs:two", "//configs:three"): [":dep2or3"]`

to

```build
"//configs:two": [":dep2or3"],
"//configs:three": [":dep2or3"],
```


## selects.with_or_dict

load("@bazel_skylib//lib:selects.bzl", "selects")

selects.with_or_dict(input_dict)

Variation of `with_or` that returns the dict of the `select()`.

Unlike `select()`, the contents of the dict can be inspected by Starlark
macros.

**PARAMETERS**

| Name  | Description | Default Value |
| :------------- | :------------- | :------------- |
| input_dict |  Same as `with_or`.   |  none |

**RETURNS**

A dictionary usable by a native `select()`.


